
 

#include "stdafx.h"
#include "WLP_DEMO.h"
#include "WLP_DEMODlg.h"
//#include "afxdialogex.h"

#include "../inc/wlp_interface.h"
#include "../inc/image_convert.h"

#include "MyButton.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif



enum GrayBit
{
	GrayBit_8 =   0XFF , //0B 1111 1111
	GrayBit_7 =   0XFE , //0B 1111 1110
	GrayBit_6 =   0XFC , //0B 1111 1100
	GrayBit_5 =   0XF8 , //0B 1111 1000
	GrayBit_4 =   0XF0 , //0B 1111 0000
	GrayBit_3 =   0XE0 , //0B 1110 0000
	GrayBit_2 =   0XC0 , //0B 1100 0000
	GrayBit_1 =   0X80 , //0B 1000 0000

};




//class CAboutDlg : public CDialog
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();


	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);   


protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()





CWLP_DEMODlg::CWLP_DEMODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWLP_DEMODlg::IDD, pParent)
	, m_frame_rate(0)
	, m_trigger_select(FALSE)
	, m_pic_cnt(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bNS_FLIP  = FALSE ;
	m_bNS_COMP_DATA = FALSE  ;

}

void CWLP_DEMODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_frame_rate);
	DDX_Check(pDX, IDC_CHECK1, m_trigger_select);
	DDX_Control(pDX, IDC_COMBO1, m_trigger_input);
	DDX_Control(pDX, IDC_COMBO2, m_trigger_output);
	DDX_Control(pDX, IDC_BUTTON1, m_btn_trigger);
	DDX_Control(pDX, IDC_COMBO3, m_gray);
	DDX_Control(pDX, IDC_BUTTON2, m_btn_start);
	DDX_Control(pDX, IDC_BUTTON3, m_btn_stop);
	DDX_Control(pDX, IDC_COMBO4, m_dmdtype);
	DDX_Control(pDX, IDC_EDIT_STATUS_REG, m_Edit_Status_Reg);
}



BEGIN_MESSAGE_MAP(CWLP_DEMODlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CWLP_DEMODlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CWLP_DEMODlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CWLP_DEMODlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CWLP_DEMODlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_CHECK1, &CWLP_DEMODlg::OnBnClickedTriggerInput)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BTN_FILE_OPEN, &CWLP_DEMODlg::OnBnClickedBtnFileOpen)
	ON_BN_CLICKED(IDC_BUTTON6, &CWLP_DEMODlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CWLP_DEMODlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CWLP_DEMODlg::OnBnClickedButton8)
END_MESSAGE_MAP()


BOOL CWLP_DEMODlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}


	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		


	m_trigger_select = TRUE;
	
	m_trigger_input.InsertString(0,L"mode four, WLP_TRIGGER_LOOP");
	m_trigger_input.InsertString(0,L"mode three,WLP_TRIGGER_FRAMES_AND_STOP");
	m_trigger_input.InsertString(0,L"mode two, WLP_TRIGGER_FRAMES");
	m_trigger_input.InsertString(0,L"mode one, WLP_TRIGGER_SINGLE_FRAME");
	m_trigger_input.SetCurSel(0);
	m_trigger_output.InsertString(0,L"mode two, WLP_SYNC_SINGLE_FRAME");
	m_trigger_output.InsertString(0,L"mode one, WLP_SYNC_ALL_FRAMES");

	m_gray.InsertString(0,L"8");
	m_gray.InsertString(0,L"6");
	m_gray.InsertString(0,L"4");
	m_gray.InsertString(0,L"2");
	m_gray.InsertString(0,L"1");
	m_gray.SetCurSel(0);

	m_dmdtype.InsertString(0,L"1080P_095A");//2
	m_dmdtype.InsertString(0,L"XGA_07A");//1
	m_dmdtype.InsertString(0,L"XGA_055A");//0
	//m_dmdtype.SetCurSel(0);

	m_trigger_output.SetCurSel(0);
	m_frame_rate = 100;
	
	m_btn_stop.EnableWindow(FALSE);

	UpdateData(FALSE);

	return TRUE;  
}



void CWLP_DEMODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}





void CWLP_DEMODlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);


		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}






HCURSOR CWLP_DEMODlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//trigger
void CWLP_DEMODlg::OnBnClickedButton1()
{


	int ret;
	WLP_HDEVICE device = 0;
	ret  = WlpDevAlloc(0,&device);
	if (ret == WLP_SUCCESS)
		printf("Load device success.\n");
	else
	{
		printf("Load device fail.\n");
		goto FAIL;
	}

	UINT param2 = 1;

	ret =  WlpDevControl(device, WLP_DEV_SIGNAL, &param2) ;
	Sleep(10);
	if (ret == WLP_SUCCESS)
		printf("signal success.\n");
	else
	{
		printf("signal fail.\n");
		goto FAIL;
	}

FAIL:
	WlpDevFree(device);
	
}




//start
void CWLP_DEMODlg::OnBnClickedButton2()
{

	if (m_filenames.size() <= 0)
		return ;

	int ret;
	WLP_HDEVICE device = 0;


	//Step 1. open device
	ret  = WlpDevAlloc(0,&device);
	if (ret == WLP_SUCCESS)
		printf("Load device success.\n");
	else
	{
		printf("Load device fail.\n");
		//goto FAIL;
		return ;
	}


	//2.reset device
	ULONG	param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_RESET, &param2) ;
	if (ret == WLP_SUCCESS)
		printf("reset device success.\n");
	else
	{
		printf("reset device fail.\n");
		goto FAIL;
	}
	//wait for reseting device to finish.
	Sleep(100);


	//3.reset dmd
	param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_DMD_RESET, &param2) ;
	if (ret == WLP_SUCCESS)
		printf("reset dmd success.\n");
	else
	{
		printf("reset dmd fail.\n");
		goto FAIL;
	}


	//wait for reseting dmd to finish.
	Sleep(100);

	UpdateData(TRUE);


	//4.init device
	DEVINIT DevInit;

	//get dmd type
	ret = WlpDevInquire( device, WLP_DEV_DMD_TYPE, &DevInit.dmdtype );
	if (ret == WLP_SUCCESS)
	{
		printf("get dmdtype success.\n");
	}
	else
	{
		printf("get dmdtype fail.\n");
		goto FAIL;
	}


	// Set the DMD type combo box in the dialog GUI
	switch( DevInit.dmdtype )
	{

	case WLP_DMDTYPE_XGA_055A:
		BitFrameSize = 1024*768/8;
		m_dmdtype.SetCurSel(0);
		m_pic_cnt = 192;
		break;

	case WLP_DMDTYPE_XGA_07A:
		BitFrameSize = 1024*768/8;
		m_dmdtype.SetCurSel(1);
		//m_pic_cnt = 192;  
		m_pic_cnt = 1;       
		break;

	case WLP_DMDTYPE_1080P_095A:
		BitFrameSize = 1920*1080/8;
		m_dmdtype.SetCurSel(2);
		m_pic_cnt = 1;      
		break;

	default:
		goto FAIL ;

	}


	DevInit.frame_freq = m_frame_rate;

	switch(m_gray.GetCurSel())
	{
		case 0:DevInit.gray = 1;break;

		case 1:DevInit.gray = 2;break;

		case 2:DevInit.gray = 4;break;

		case 3:DevInit.gray = 6;break;

		case 4:DevInit.gray = 8;break;

	}
	
	
	if (m_trigger_select)
	{
		DevInit.trigger_setting = WLP_TRIGGER_ENABLE;
	}
	else
	{
		DevInit.trigger_setting = WLP_TRIGGER_DISABLE;
	}


	switch( m_trigger_input.GetCurSel() )
	{

		case 0:DevInit.trigger_setting |= WLP_TRIGGER_SINGLE_FRAME;break;

		case 1:DevInit.trigger_setting |= WLP_TRIGGER_FRAMES;break;

		case 2:DevInit.trigger_setting |= WLP_TRIGGER_FRAMES_AND_AUTOSTOP;break;

		case 3:DevInit.trigger_setting |= WLP_TRIGGER_LOOP;break;

	}



	switch( m_trigger_output.GetCurSel() )
	{

		case 0:DevInit.trigger_setting |= WLP_SYNC_ALL_FRAMES;break;

		case 1:DevInit.trigger_setting |= WLP_SYNC_SINGLE_FRAME;break;

	}

	ret = WlpDevInit( device , &DevInit );
	if (ret == WLP_SUCCESS)
	{
		printf("Init success.\n");

	}
	else
	{
		printf("Inti fail.\n");
	
		goto FAIL;
	}


	//5.set download addr
	param2 = 0;
	ret =  WlpDevControl( device, WLP_DEV_FRAME_DOWNLOAD_ADDR, &param2 ) ;
	if (ret == WLP_SUCCESS)
	{
		printf("set download addr success.\n");
	}
	else
	{
		printf("set download addr fail.\n");
		goto FAIL;
	}



	//6.calc DownLoadLen width * height 

	ULONG DownLoadLen = BitFrameSize * DevInit.gray;

	// malloc memory for the image data to be download
	PUCHAR pLargeImageBuff ;
	pLargeImageBuff = (PUCHAR)malloc( DownLoadLen*m_filenames.size() );
	memset( pLargeImageBuff , 0X00 , sizeof(UCHAR)*DownLoadLen*m_filenames.size()  ) ;

	// Set the image size
	int width  = 0 ;
	int height = 0 ; 

	switch( DevInit.dmdtype )
	{

	case WLP_DMDTYPE_XGA_055A:
		width  = 1024 ;
		height =  768 ;
		break;

	case WLP_DMDTYPE_XGA_07A:
		width  = 1024 ;
		height =  768 ;
		break;

	case WLP_DMDTYPE_1080P_095A:
		width  = 1920 ;
		height = 1080 ;
		break;

	default:
		goto FAIL ;

	}

	// set bitmask  
	UCHAR bitmask = 0 ;

	if ( DevInit.gray == 1 )
	{
		bitmask = GrayBit_1;
	}
	else if (  DevInit.gray == 2 )
	{
		bitmask = GrayBit_2;
	}
	else if (  DevInit.gray == 3 )
	{
		bitmask = GrayBit_3;
	}
	else if (  DevInit.gray == 4 )
	{
		bitmask = GrayBit_4;
	}
	else if (  DevInit.gray == 5 )
	{
		bitmask = GrayBit_5;
	}
	else if (  DevInit.gray == 6 )
	{
		bitmask = GrayBit_6;
	}
	else if (  DevInit.gray == 7 )
	{
		bitmask = GrayBit_7;
	}
	else
	{
		bitmask = GrayBit_8;
	}


	// convert image file to the format that proper for downloading 
	for( int i = 1 ;  i <= m_filenames.size() ;i++  )
	{

		PUCHAR pImageBuff = (PUCHAR)malloc( DownLoadLen );  //one frame

		CString m_filename = m_filenames[i-1];
		if (m_filename.IsEmpty())
		{
			goto FAIL;
		}


		GetGrayBinFormat( CT2CA(m_filename),
						  width,
						  height, 
						  bitmask , 
						  (PCHAR)pImageBuff ) ;

		memcpy( pLargeImageBuff + (i-1)* DownLoadLen , pImageBuff , DownLoadLen ) ;

		free( pImageBuff );

	} 


	//7. download frame data to DMD
	ret = WlpDevLoadFrame( device , pLargeImageBuff , DownLoadLen*(m_filenames.size())  ) ;


	if ( ret == WLP_SUCCESS )
	{
		printf("Load frames success.\n");
	}
	else
	{
		printf("Load frames fail.\n");

		goto FAIL ;

	}

	free( pLargeImageBuff );


	//8.set frames cnt

	param2 = m_pic_cnt * DevInit.gray ;

	ret =  WlpDevControl( device , WLP_DEV_FRAME_CNT , &param2 ) ;
	if( ret == WLP_SUCCESS )
	{
		printf("set frame cnt.\n");
	}
	else
	{
		printf("set frame cnt fail.\n");

		goto FAIL;
	}
	

	//9.start dmd
	param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_DMD_START, &param2) ;
	if (ret == WLP_SUCCESS)
	{
		printf("start dmd success.\n");
	}
	else
	{
		printf("start dmd fail.\n");

		goto FAIL;
	}


	//wait for starting dmd to finish.
	Sleep(100);


	m_btn_start.EnableWindow(FALSE);
	m_btn_stop.EnableWindow(TRUE);



FAIL:
	WlpDevFree(device);


}





//stop
void CWLP_DEMODlg::OnBnClickedButton3()
{

	int ret;
	WLP_HDEVICE device = 0;


	ret  = WlpDevAlloc(0,&device);
	if (ret == WLP_SUCCESS)
		printf("Load device success.\n");
	else
	{
		printf("Load device fail.\n");
		goto FAIL;
	}

	UINT param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_DMD_STOP, &param2) ;
	if (ret == WLP_SUCCESS)
		printf("stop dmd success.\n");
	else
	{
		printf("stop dmd fail.\n");
		goto FAIL;
	}

	m_btn_start.EnableWindow(TRUE);
	m_btn_stop.EnableWindow(FALSE);


FAIL:
	WlpDevFree(device);


}



//exit
void CWLP_DEMODlg::OnBnClickedButton4()
{

	CDialog::OnOK();

}




// Trigger input mode 
void CWLP_DEMODlg::OnBnClickedTriggerInput()
{


	UpdateData(TRUE);
	if (m_trigger_select)
	{
		m_trigger_input.EnableWindow(TRUE);
		m_btn_trigger.EnableWindow(TRUE);
	}
	else
	{
		m_trigger_input.EnableWindow(FALSE);
		m_btn_trigger.EnableWindow(FALSE);
	}
}





//Scrolling effect
PUCHAR CWLP_DEMODlg::PicTo768Pic8Bit(PUCHAR pData, LONG gray)
{

	PUCHAR pMalloc = (PUCHAR)malloc(BitFrameSize*gray*m_pic_cnt);
	if (pMalloc == NULL)
	{
		return NULL;
	}


	PUCHAR pTmpData = (PUCHAR)malloc(BitFrameSize*gray*2);
	if (pTmpData == NULL)
	{
		free(pMalloc);

		return NULL;
	}


	for (LONG i = 0; i < gray; i++)
	{
		memmove(pTmpData + BitFrameSize * i * 2,       pData + BitFrameSize*i, BitFrameSize );
		memmove(pTmpData + BitFrameSize * (i * 2 + 1), pData + BitFrameSize*i, BitFrameSize );
	}

	PUCHAR pTmp;
	
	for(LONG i = 0; i < m_pic_cnt; i++)
	{
		pTmp = pMalloc + i * BitFrameSize * gray;

		for (LONG j = 0; j < gray; j++)
		{

			PUCHAR pSrc = pTmpData + j * BitFrameSize*2 ;
			PUCHAR pDes = pTmp     + j * BitFrameSize ;

			if (BitFrameSize == 1920*1080/8)
			{
				memmove(pDes, pSrc + 240*i*4, BitFrameSize);
			}
			else
			{
				memmove(pDes, pSrc + 128*i*4, BitFrameSize);
			}

		}
	}

	free(pTmpData);

	return pMalloc;

}




void CWLP_DEMODlg::OnLButtonDown(UINT nFlags, CPoint point)
{


	CDialog::OnLButtonDown(nFlags, point);
}



//Open file 
void CWLP_DEMODlg::OnBnClickedBtnFileOpen()
{



	CFileDialog dlg(TRUE, NULL, NULL, OFN_ALLOWMULTISELECT|OFN_FILEMUSTEXIST,    
		L"ͼƬļ(*.jpg)|*.jpg|All(*.*)|*.bmp|", this);  

	if ( IDOK == dlg.DoModal() )   
	{   
		POSITION pos = dlg.GetStartPosition();  
		m_filenames.clear();
		while ( NULL != pos )   
		{   
			CString str = dlg.GetNextPathName(pos);  
			m_filenames.push_back(str);
		}   
	}  


}



// Open device 
void CWLP_DEMODlg::OnBnClickedButton6(  )
{


	LONG ret;
	WLP_HDEVICE device = 0;

	//1. open
	ret  = WlpDevAlloc(0,&device);
	if (ret == WLP_SUCCESS)
		printf("Load device success.\n");
	else
	{
		printf("Load device fail.\n");
		MessageBox( NULL, _T( "Open Device Fail! " ),   MB_OK|MB_ICONINFORMATION ); 
		goto FAIL;

	}

	LONG param;
	ret = WlpDevInquire( device, WLP_DEV_DMD_TYPE, &param );
	if (ret == WLP_SUCCESS)
		printf("get dmdtype success.\n");
	else
	{
		printf("get dmdtype fail.\n");
		goto FAIL;
	}

	switch(param)
	{

	case WLP_DMDTYPE_XGA_055A:	
		m_dmdtype.SetCurSel(0);
		break;

	case WLP_DMDTYPE_XGA_07A:		
		m_dmdtype.SetCurSel(1);
		break;

	case WLP_DMDTYPE_1080P_095A:	
		m_dmdtype.SetCurSel(2);
		break;

	default:
		goto FAIL;

	}




FAIL:

	WlpDevFree(device);


}

void CWLP_DEMODlg::OnBnClickedButton7()
{



	LONG ret;
	WLP_HDEVICE device = 0;

	//1. open
	ret  = WlpDevAlloc(0,&device);
	if (ret == WLP_SUCCESS)
		printf("Load device success.\n");
	else
	{
		printf("Load device fail.\n");
		MessageBox( NULL, _T( "Open Device Fail! " ),   MB_OK|MB_ICONINFORMATION ); 
	
	 	return ;

	}


	UINT param = 0;
	if ( m_bNS_FLIP == FALSE )
	{
		param = TRUE ;
	}
	else
	{
		param = FALSE ;

	}

	ret =  WlpDevControl( device , WLP_DEV_NS_FLIP , &param ) ;
	if( ret == WLP_SUCCESS )
	{
		printf("set NS_FLIP.\n");

		m_bNS_FLIP = param ;
	}
	else
	{
		printf("set NS_FLIP fail.\n");

	}


	LONG StatusRegValue;
	ret = WlpDevInquire( device, WLP_DEV_STATUS_ALLBITS , &StatusRegValue );
	if (ret == WLP_SUCCESS)
		printf("get dmdtype success.\n");
	else
	{
		printf("get dmdtype fail.\n");
	 	return ;
	}



	CString str  ;
	str.Format( _T("%8X"),   StatusRegValue);

	SetDlgItemText(IDC_EDIT_STATUS_REG , str); 

}






void CWLP_DEMODlg::OnBnClickedButton8()
{
	// TODO: Add your control notification handler code here

	LONG ret;
	WLP_HDEVICE device = 0;

	//1. open
	ret  = WlpDevAlloc(0,&device);
	if (ret == WLP_SUCCESS)
		printf("Load device success.\n");
	else
	{
		printf("Load device fail.\n");
		MessageBox( NULL, _T( "Open Device Fail! " ),   MB_OK|MB_ICONINFORMATION ); 

		return ;

	}


	UINT param = 0;
	if ( m_bNS_COMP_DATA == FALSE )
	{
		param = TRUE ;
	}
	else
	{
		param = FALSE ;

	}

	ret =  WlpDevControl( device , WLP_DEV_COMP_DATA , &param ) ;
	if( ret == WLP_SUCCESS )
	{
		printf("set NS_FLIP.\n");

		m_bNS_COMP_DATA = param ; 
	}
	else
	{
		printf("set NS_FLIP fail.\n");

	}


	LONG StatusRegValue;
	ret = WlpDevInquire( device, WLP_DEV_STATUS_ALLBITS, &StatusRegValue );
	if (ret == WLP_SUCCESS)
		printf("get dmdtype success.\n");
	else
	{
		printf("get dmdtype fail.\n");
		return ;
	}

	CString str  ;
	str.Format( _T("%8X"),   StatusRegValue);

	SetDlgItemText(IDC_EDIT_STATUS_REG , str); 


}
